clear all;

c = -1;
k = 3;
AnzKno = 2^k-1; % Wurzel der Anzahl der Knoten im Inneren
h = 2^(-k);

Knotenmatrix = zeros(k^2,2);
Dreiecksmatrix = zeros(2*(k+1)^2,3);

% Konten im Inneren

for i = 1:AnzKno
    for j = 1:AnzKno
        Knotenmatrix(j+(i-1)*AnzKno,1) = j*h;
        Knotenmatrix(j+(i-1)*AnzKno,2) = i*h;
    end
end

% Randknoten

for i = 1:AnzKno+1
    Knotenmatrix(AnzKno^2+i,1) = (i-1)*h;
    Knotenmatrix(AnzKno^2+i,2) = 0;
    
    Knotenmatrix(AnzKno^2+AnzKno+1+i,1) = 1;
    Knotenmatrix(AnzKno^2+AnzKno+1+i,2) = (i-1)*h;
    
    Knotenmatrix(AnzKno^2+2*(AnzKno+1)+i,1) = 1-(i-1)*h;
    Knotenmatrix(AnzKno^2+2*(AnzKno+1)+i,2) = 1;
    
    Knotenmatrix(AnzKno^2+3*(AnzKno+1)+i,1) = 0;
    Knotenmatrix(AnzKno^2+3*(AnzKno+1)+i,2) = 1-(i-1)*h;
end

% Nummerierung der Inneren Dreiecke

for i = 1:(AnzKno-1)
    for j = 1:(AnzKno-1)
        
        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+i,1) = i+(j-1)*AnzKno;
        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+i,2) = i+1+(j-1)*AnzKno;
        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+i,3) = j*AnzKno+i;

        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+(AnzKno-1)+i,1) = i+1+(j-1)*AnzKno;
        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+(AnzKno-1)+i,2) = AnzKno+i+1+(j-1)*AnzKno;
        Dreiecksmatrix(2*(AnzKno-1)*(j-1)+(AnzKno-1)+i,3) = AnzKno+i+(j-1)*AnzKno;
        
    end
end

Dreiecksmatrix(2*(AnzKno-1)^2+1, 1) = AnzKno^2+1;
Dreiecksmatrix(2*(AnzKno-1)^2+1, 2) = AnzKno^2+2;
Dreiecksmatrix(2*(AnzKno-1)^2+1, 3) = (AnzKno+2)^2;

% Rand

for i=1:AnzKno
    Dreiecksmatrix(2*(AnzKno-1)^2+1+i, 1) = AnzKno^2+1+i;
    Dreiecksmatrix(2*(AnzKno-1)^2+1+i, 2) = AnzKno^2+2+i;
    Dreiecksmatrix(2*(AnzKno-1)^2+1+i, 3) = i;
end
    
    

A = zeros (AnzKno^2, AnzKno^2);
a = [1/12 1/24 1/24; 1/24 1/12 1/24; 1/24 1/24 1/12]; % von Vita
grad = [1 -0.5 -0.5; -0.5 0.5 0; -0.5 0 0.5];
a = a*c*h^2 - grad;

for i = 1:(2*(k+1)^2)
    x(1) = Dreiecksmatrix(i,1);
    x(2) = Dreiecksmatrix(i,2);
    x(3) = Dreiecksmatrix(i,3);
    for j = 1:3
        for k = 1:3
            A(x(k), x(j)) = A(x(k), x(j)) + a(k,j);
        end
    end
end
